package net.thehelper.blackhole;

import java.io.File;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import net.thehelper.blackhole.model.Workspace;

import org.w3c.dom.Document;

public class SC2LibOutput {
	private Document doc;

	public void writeToFile(File file)
			throws TransformerFactoryConfigurationError, TransformerException {
		Transformer transformer = TransformerFactory.newInstance().newTransformer();
		transformer.setOutputProperty(OutputKeys.INDENT, "yes");
		transformer.transform(new DOMSource(doc), new StreamResult(file));
	}

	public SC2LibOutput() throws ParserConfigurationException {
		doc = DocumentBuilderFactory.newInstance().newDocumentBuilder()
				.newDocument();
	}

	public void parseWorkspace(Workspace workspace) {
		OutStream outStream = new OutStream(doc);
		workspace.appendToXML(outStream);
		outStream.seal();
	}
}

/*
 * <root> <!--Just a thought--> <child name="value">Filler, ... I could have had
 * a FOO!</child> </root>
 * 
 * =====
 * 
 * try { ///////////////////////////// //Creating an empty XML Document
 * 
 * //We need a Document DocumentBuilderFactory dbfac =
 * DocumentBuilderFactory.newInstance(); DocumentBuilder docBuilder =
 * dbfac.newDocumentBuilder(); Document doc = docBuilder.newDocument();
 * 
 * //////////////////////// //Creating the XML tree
 * 
 * //create the root element and add it to the document Element root =
 * doc.createElement("root"); doc.appendChild(root);
 * 
 * //create a comment and put it in the root element Comment comment =
 * doc.createComment("Just a thought"); root.appendChild(comment);
 * 
 * //create child element, add an attribute, and add to root Element child =
 * doc.createElement("child"); child.setAttribute("name", "value");
 * root.appendChild(child);
 * 
 * //add a text element to the child Text text =
 * doc.createTextNode("Filler, ... I could have had a foo!");
 * child.appendChild(text);
 * 
 * ///////////////// //Output the XML
 * 
 * //set up a transformer TransformerFactory transfac =
 * TransformerFactory.newInstance(); Transformer trans =
 * transfac.newTransformer();
 * trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
 * trans.setOutputProperty(OutputKeys.INDENT, "yes");
 * 
 * //create string from xml tree StringWriter sw = new StringWriter();
 * StreamResult result = new StreamResult(sw); DOMSource source = new
 * DOMSource(doc); trans.transform(source, result); String xmlString =
 * sw.toString();
 * 
 * //print xml System.out.println("Here's the xml:\n\n" + xmlString);
 * 
 * } catch (Exception e) { System.out.println(e); }
 */
