package net.thehelper.blackhole.model;

import java.util.Map;
import java.util.Map.Entry;

import net.thehelper.blackhole.OutStream;
import net.thehelper.galaxyutils.ParseUtils;

public class BasicStatement extends ScriptElement {
	private String statement;

	public BasicStatement(String statement) {
		this.statement = statement;
	}

	@Override
	public void appendToXML(OutStream outStream) {
		outStream.appendGalaxyLine(statement);
	}

	@Override
	public String getName() {
		throw new UnsupportedOperationException(
				"Cannot get the name of a Basic Statement");
	}

	@Override
	public void constructNameMapping(Map<String, ScriptElement> nameMapping) {
	}

	@Override
	public String performMapping(String input) {
		return input;
	}

	@Override
	public void mapNames(Map<String, ScriptElement> nameMapping) {
		for (Entry<String, ScriptElement> mapping : nameMapping.entrySet()) {
			if (ParseUtils.containsRegex(statement, mapping.getKey())) {
				statement = mapping.getValue().performMapping(statement);
			}
		}
	}

	@Override
	public void resolveParents() {
	}

}
