package net.thehelper.blackhole.model;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import net.thehelper.blackhole.OutStream;

public class ComplexStatement extends ScriptElement {
	private String statement;
	private List<ScriptElement> contents = new LinkedList<ScriptElement>();

	public List<ScriptElement> getContents() {
		return contents;
	}

	public ComplexStatement(String statement) {
		this.statement = statement;
	}

	@Override
	public void appendToXML(OutStream outStream) {
		outStream.appendGalaxyLine(statement);
		for (ScriptElement statement : contents) {
			statement.appendToXML(outStream);
		}
	}

	@Override
	public String getName() {
		throw new UnsupportedOperationException(
				"Cannot get the name of a Complex Statement.");
	}

	@Override
	public void constructNameMapping(Map<String, ScriptElement> nameMapping) {
	}

	@Override
	public void mapNames(Map<String, ScriptElement> nameMapping) {
		for (Entry<String, ScriptElement> mapping : nameMapping.entrySet()) {
			if (statement.contains(mapping.getKey())) {
				statement = mapping.getValue().performMapping(statement);
			}
		}
		for (ScriptElement element : contents) {
			element.mapNames(nameMapping);
		}
	}

	@Override
	public String performMapping(String input) {
		return input;
	}

	@Override
	public void resolveParents() {
		for (ScriptElement element : contents) {
			element.setParent(this);
			element.resolveParents();
		}
	}

}
