package net.thehelper.blackhole.model;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import net.thehelper.blackhole.OutStream;

public class InitBlock extends ScriptElement {
	private List<ScriptElement> contents = new LinkedList<ScriptElement>();

	public List<ScriptElement> getContents() {
		return contents;
	}

	@Override
	public void appendToXML(OutStream outStream) {
		outStream.addInitMode(true);
		for (ScriptElement statement : contents) {
			statement.appendToXML(outStream);
		}
		outStream.remoteInitMode();
	}

	@Override
	public String getName() {
		throw new UnsupportedOperationException("Cannot get the name of an Init block.");
	}

	@Override
	public void constructNameMapping(Map<String, ScriptElement> nameMapping) {
	}

	@Override
	public void mapNames(Map<String, ScriptElement> nameMapping) {
		for (ScriptElement element : contents) {
			element.mapNames(nameMapping);
		}
	}

	@Override
	public String performMapping(String input) {
		return input;
	}

	@Override
	public void resolveParents() {
		for (ScriptElement element : contents) {
			element.setParent(this);
			element.resolveParents();
		}
	}

}
