package net.thehelper.blackhole.model;

import java.util.Map;

import net.thehelper.blackhole.OutStream;

public abstract class ScriptElement {
	private ScriptElement parent;
	
	public ScriptElement getParent() {
		return parent;
	}

	public void setParent(ScriptElement parent) {
		this.parent = parent;
	}

	public abstract void appendToXML(OutStream outStream);

	public abstract String getName();

	public abstract void constructNameMapping(Map<String, ScriptElement> nameMapping);

	public abstract void mapNames(Map<String, ScriptElement> nameMapping);
	
	public abstract String performMapping(String input);
	public abstract void resolveParents();
}
