package net.thehelper.blackhole.voidparser;

import java.io.IOException;
import java.text.ParseException;

import net.thehelper.blackhole.model.ComplexStatement;
import net.thehelper.blackhole.model.ScriptElement;

public class VoidscriptComplexStatementParser extends VoidscriptElementParser {

	public VoidscriptComplexStatementParser() {
		addSubParser(new VoidscriptBasicStatementParser());
		addSubParser(this); // no infinite loop.
	}

	@Override
	public ScriptElement parse(InStream inStream) throws ParseException,
			IOException {
		if (inStream.peekStatement().endsWith("{")) {
			String statement = inStream.popStatement();
			int lineNum = inStream.getLastStatementStartLine();

			ComplexStatement newCompoundStatement = new ComplexStatement(
					statement);

			while (true) {
				ScriptElement newStatement = subParse(inStream);
				if (newStatement == null) {
					statement = inStream.popStatement();
					lineNum = inStream.getLastStatementStartLine();
					if (statement == null) {
						throw new ParseException("Statement was not closed!",
								lineNum);
					}
					if (statement.equals("}")) {
						return newCompoundStatement;
					}
					throw new ParseException("Unexpected statement: "
							+ statement, lineNum);
				}
				newCompoundStatement.getContents().add(newStatement);
			}

		}
		return null;
	}

}
