package net.thehelper.blackhole.voidparser;

import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

import net.thehelper.blackhole.model.ScriptElement;
import net.thehelper.blackhole.model.modifier.Modifier;
import net.thehelper.blackhole.model.modifier.ModifierParser;

public abstract class VoidscriptElementParser {
	private List<VoidscriptElementParser> subParsers = new ArrayList<VoidscriptElementParser>();
	private List<ModifierParser> modifierParsers = new ArrayList<ModifierParser>();

	protected void addSubParser(VoidscriptElementParser parser) {
		subParsers.add(parser);
	}

	protected void addModifierParser(ModifierParser parser) {
		modifierParsers.add(parser);
	}

	protected String parseModifier(Modifier mod, String toParse) {
		for (ModifierParser parser : modifierParsers) {
			toParse = parser.parse(mod, toParse);
		}
		return toParse;
	}

	protected ScriptElement subParse(InStream inStream) throws ParseException,
			IOException {
		ScriptElement parsedElement;
		for (VoidscriptElementParser parser : subParsers) {
			parsedElement = parser.parse(inStream);
			if (parsedElement != null) {
				return parsedElement;
			}
		}
		return null;
	}

	public abstract ScriptElement parse(InStream inStream)
			throws ParseException, IOException;
}
