package net.thehelper.blackhole.voidparser;

import java.io.IOException;
import java.text.ParseException;

import net.thehelper.blackhole.model.InitBlock;
import net.thehelper.blackhole.model.ScriptElement;

public class VoidscriptInitParser extends VoidscriptElementParser {

	public VoidscriptInitParser() {
		addSubParser(new VoidscriptBasicStatementParser());
		addSubParser(new VoidscriptComplexStatementParser());
	}

	@Override
	public InitBlock parse(InStream inStream) throws ParseException,
			IOException {
		if (inStream.peekStatement().matches("init[ 	]*\\{")) {
			String statement = inStream.popStatement();
			int lineNum = inStream.getLastStatementStartLine();

			InitBlock newInit = new InitBlock();

			while (true) {
				ScriptElement newStatement = subParse(inStream);
				if (newStatement == null) {
					statement = inStream.popStatement();
					lineNum = inStream.getLastStatementStartLine();
					if (statement == null) {
						throw new ParseException("Init block was not closed!",
								lineNum);
					}
					if (statement.equals("}")) {
						return newInit;
					}
					throw new ParseException("Unexpected statement: "
							+ statement, lineNum);
				}
				newInit.getContents().add(newStatement);
			}

		}
		return null;
	}

}
