package net.thehelper.blackhole.voidparser;

import java.io.IOException;
import java.text.ParseException;

import net.thehelper.blackhole.model.Library;
import net.thehelper.blackhole.model.ScriptElement;
import net.thehelper.blackhole.model.Workspace;

public class VoidscriptWorkspaceParser extends VoidscriptElementParser {
	private Workspace workspace;

	public VoidscriptWorkspaceParser(Workspace workspace) {
		this.workspace = workspace;
		addSubParser(new VoidscriptLibraryParser());
	}

	@Override
	public ScriptElement parse(InStream inStream) throws IOException,
			ParseException {
		for (String line = inStream.peekStatement(); line != null; line = inStream
				.peekStatement()) {

			int lineNumber = inStream.getReadLineCount();
			Library newLib = (Library) subParse(inStream);
			if (newLib == null) {
				throw new ParseException("Unknown statement: " + line,
						lineNumber);
			}
			if (workspace.getLibraries().put(newLib.getName(), newLib) != null) {
				throw new ParseException("Library " + newLib.getName()
						+ " redeclared at line: " + line, lineNumber);
			}
		}
		return null;
	}
}
