package net.thehelper.galaxyutils;

import junit.framework.TestCase;

public class GalaxyUtilsTest extends TestCase {
	
	public void testStripLineComments() {
		assertEquals("test", GalaxyUtils.stripLineComments("test // test"));
		assertEquals("test", GalaxyUtils.stripLineComments("test"));
		assertEquals("", GalaxyUtils.stripLineComments("//test"));
		assertEquals("'//'", GalaxyUtils.stripLineComments("'//'"));
		assertEquals("\"//\"", GalaxyUtils.stripLineComments("\"//\""));
	}
	
	public void testStripBlockComments() {
		assertEquals("test", GalaxyUtils.stripBlockComments("test /* test */"));
		assertEquals("test", GalaxyUtils.stripBlockComments("test"));
		assertEquals("", GalaxyUtils.stripBlockComments("/*test*/"));
		assertEquals("test", GalaxyUtils.stripBlockComments("te/*comment*/st"));
		assertEquals("test", GalaxyUtils.stripBlockComments("t/*();*/es/*comment*/t"));
	}
}
